package top.imwork.window.silos.controller.upms;

import jakarta.annotation.Resource;
import jakarta.validation.Valid;
import org.springframework.web.bind.annotation.*;

import top.imwork.commons.core.pojo.ResponseMsg;
import top.imwork.commons.core.pojo.DeleteParams;
import top.imwork.commons.core.base.BaseController;
import top.imwork.window.silos.convert.upms.RegionConvert;
import top.imwork.window.silos.pojo.upms.bo.RegionBO;
import top.imwork.window.silos.pojo.upms.bo.RegionResultBO;
import top.imwork.window.silos.pojo.upms.po.RegionListParamVO;
import top.imwork.window.silos.pojo.upms.po.RegionParamVO;
import top.imwork.window.silos.service.upms.IRegionService;

/**
 * 地理信息
 *
 * @author jiangxiaowei
 * email: e-jiangxiaowei@outlook.com
 * date: 2025-12-11 13:37:18
 */
@RestController
@RequestMapping("/region")
public class RegionServiceController extends BaseController{

    @Resource
    public IRegionService regionService;

    /**
     * 根据id查询数据
     * @param id long类型的id
     * @return 返回查询结果
     */
    @GetMapping("/info/{id}")
    public ResponseMsg info(@PathVariable("id") Long id){
        return ResponseMsg.buildResponse(regionService.info(id));
    }

    /**
     * 新增/修改info
     * @param regionParamVO 实体信息
     * @return responseMsg 操作结果
     */
    @PostMapping("/save")
    public ResponseMsg save(@RequestBody @Valid RegionParamVO regionParamVO){
        RegionBO regionBO = regionService.save(RegionConvert.regionParamVoToDto(regionParamVO));
        return ResponseMsg.buildResponse(RegionConvert.regionBoToVo(regionBO));
    }

    /**
     * 根据id删除地理信息
     * @param id id
     * @return true/false 成功/失败
     */
    @DeleteMapping("/delete/{id}")
    public ResponseMsg delete(@PathVariable("id") Long id){
        return regionService.delete(id)? ResponseMsg.ok() : ResponseMsg.fail();
    }

    /**
     * 批量逻辑删除信息
     *
     * @param dto 删除条件
     * @return true/false 是否删除成功
     */
    @DeleteMapping("/deleteByIds")
    public ResponseMsg deleteByIds(@RequestBody DeleteParams dto){
        String[] idArr = dto.getIds().split(",");
        return regionService.deleteByIds(idArr)? ResponseMsg.ok() : ResponseMsg.fail();
    }

    @PostMapping("/queryPage")
    public ResponseMsg queryPage(@RequestBody @Valid RegionListParamVO regionListParamVO) {
        RegionResultBO regionResultBO = regionService.queryPage(RegionConvert.regionListParamVoToDTO(regionListParamVO));
        return ResponseMsg.buildResponse(RegionConvert.regionResultBoToVo(regionResultBO));
    }
}
